package ovh.herisson.Clyde.Repositories;

import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import ovh.herisson.Clyde.Tables.Curriculum;
import ovh.herisson.Clyde.Tables.Lesson;
import ovh.herisson.Clyde.Tables.Schedule;
import ovh.herisson.Clyde.Tables.ScheduleLesson;

public interface ScheduleLessonRepository extends CrudRepository<ScheduleLesson,Long> {

    @Query("select distinct sl.lesson from ScheduleLesson sl where sl.schedule.curriculum = ?1")
    Iterable<Lesson> findLessonByCurriculum(Curriculum curriculum);

    @Query("select distinct sl.schedule from ScheduleLesson sl")
    Iterable<Schedule> findDistinctSchedule();

    @Query("select distinct sl.schedule from ScheduleLesson sl where sl.schedule.curriculum = ?1")
    Schedule findScheduleByCurriculum(Curriculum curriculum);

    @Query("select distinct sl.lesson from ScheduleLesson sl where sl.schedule = ?1")
    Iterable<Lesson> findLessonBySchedule(Schedule schedule);
}
