package ovh.herisson.Clyde.Services;

import org.springframework.stereotype.Service;
import ovh.herisson.Clyde.Repositories.LessonRepository;
import ovh.herisson.Clyde.Tables.Lesson;
import ovh.herisson.Clyde.Tables.Role;
import ovh.herisson.Clyde.Tables.User;
import java.util.Map;

@Service
public class LessonService {
    private final LessonRepository lessonRepo;
    public LessonService(LessonRepository lessonRepo){
        this.lessonRepo = lessonRepo;
    }

    public Lesson save(Lesson lesson){
        return lessonRepo.save(lesson);
    }
    public Lesson findById(long id){
        return lessonRepo.findById(id);
    }
    public Iterable<Lesson> findAll(){return lessonRepo.findAll();}

    public Iterable<Lesson> findAllOwnedLesson(User teacher){
        return lessonRepo.findAllOwnedLesson(teacher);
    }

    public boolean modifyData(long id, Map<String ,Object> updates, Role role){
        Lesson target = lessonRepo.findById(id);

        if(target == null || role != Role.Secretary)
            return false;


        for (Map.Entry<String , Object> entry: updates.entrySet()){
            switch (entry.getKey()){
                case "lessonStart":
                    target.setLessonStart((String) entry.getValue());
                    break;
                case "lessonEnd":
                    target.setLessonEnd((String) entry.getValue());
                case "color":
                    target.setColor((String) entry.getValue());
                    break;
                case "local":
                    target.setLocal((String) entry.getValue());
            }
        }
        lessonRepo.save(target);
        return true;
    }

    public void delete(Lesson lesson){
        lessonRepo.delete(lesson);
    }


}
